# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from typing import Any, Dict, List, Optional, Tuple, Union

from getopenpay.api_client import ApiClient, RequestSerialized
from getopenpay.api_response import ApiResponse
from getopenpay.models.create_promo_code_request import CreatePromoCodeRequest
from getopenpay.models.list_response_promotion_code_external import (
  ListResponsePromotionCodeExternal
)
from getopenpay.models.promo_code_query_params import PromoCodeQueryParams
from getopenpay.models.promotion_code_external import PromotionCodeExternal
from getopenpay.models.update_promo_code_request import UpdatePromoCodeRequest
from getopenpay.rest import RESTResponseType
from pydantic import Field, StrictFloat, StrictInt, StrictStr, validate_call
from typing_extensions import Annotated


class PromotionCodesApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_call
  def create_promo_code(
    self,
    create_promo_code_request: CreatePromoCodeRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PromotionCodeExternal:
    """Create Promo Code


        :param create_promo_code_request: (required)
        :type create_promo_code_request: CreatePromoCodeRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_promo_code_serialize(
      create_promo_code_request=create_promo_code_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def create_promo_code_with_http_info(
    self,
    create_promo_code_request: CreatePromoCodeRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PromotionCodeExternal]:
    """Create Promo Code


        :param create_promo_code_request: (required)
        :type create_promo_code_request: CreatePromoCodeRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_promo_code_serialize(
      create_promo_code_request=create_promo_code_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def create_promo_code_without_preload_content(
    self,
    create_promo_code_request: CreatePromoCodeRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Create Promo Code


        :param create_promo_code_request: (required)
        :type create_promo_code_request: CreatePromoCodeRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._create_promo_code_serialize(
      create_promo_code_request=create_promo_code_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '201': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _create_promo_code_serialize(
    self,
    create_promo_code_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> RequestSerialized:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if create_promo_code_request is not None:
      _body_params = create_promo_code_request

    # set the HTTP header `Accept`
    if 'Accept' not in _header_params:
      _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/promotion-codes/',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def get_promo_code(
    self,
    promo_code_id: Annotated[StrictStr,
                             Field(description='Unique identifier of the PromotionCode.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PromotionCodeExternal:
    """Get Promo Code


        :param promo_code_id: Unique identifier of the PromotionCode. (required)
        :type promo_code_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_promo_code_serialize(
      promo_code_id=promo_code_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def get_promo_code_with_http_info(
    self,
    promo_code_id: Annotated[StrictStr,
                             Field(description='Unique identifier of the PromotionCode.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PromotionCodeExternal]:
    """Get Promo Code


        :param promo_code_id: Unique identifier of the PromotionCode. (required)
        :type promo_code_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_promo_code_serialize(
      promo_code_id=promo_code_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def get_promo_code_without_preload_content(
    self,
    promo_code_id: Annotated[StrictStr,
                             Field(description='Unique identifier of the PromotionCode.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Get Promo Code


        :param promo_code_id: Unique identifier of the PromotionCode. (required)
        :type promo_code_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_promo_code_serialize(
      promo_code_id=promo_code_id,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _get_promo_code_serialize(
    self,
    promo_code_id,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> RequestSerialized:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if promo_code_id is not None:
      _path_params['promo_code_id'] = promo_code_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    if 'Accept' not in _header_params:
      _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='GET',
      resource_path='/promotion-codes/{promo_code_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def get_promo_code_by_code(
    self,
    promo_code: Annotated[StrictStr, Field(description='Unique PromotionCode code.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PromotionCodeExternal:
    """Get Promo Code By Code


        :param promo_code: Unique PromotionCode code. (required)
        :type promo_code: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_promo_code_by_code_serialize(
      promo_code=promo_code,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def get_promo_code_by_code_with_http_info(
    self,
    promo_code: Annotated[StrictStr, Field(description='Unique PromotionCode code.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PromotionCodeExternal]:
    """Get Promo Code By Code


        :param promo_code: Unique PromotionCode code. (required)
        :type promo_code: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_promo_code_by_code_serialize(
      promo_code=promo_code,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def get_promo_code_by_code_without_preload_content(
    self,
    promo_code: Annotated[StrictStr, Field(description='Unique PromotionCode code.')],
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Get Promo Code By Code


        :param promo_code: Unique PromotionCode code. (required)
        :type promo_code: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._get_promo_code_by_code_serialize(
      promo_code=promo_code,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _get_promo_code_by_code_serialize(
    self,
    promo_code,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> RequestSerialized:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if promo_code is not None:
      _path_params['promo_code'] = promo_code
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter

    # set the HTTP header `Accept`
    if 'Accept' not in _header_params:
      _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='GET',
      resource_path='/promotion-codes/code/{promo_code}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def list_promo_codes(
    self,
    promo_code_query_params: PromoCodeQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ListResponsePromotionCodeExternal:
    """List Promo Codes


        :param promo_code_query_params: (required)
        :type promo_code_query_params: PromoCodeQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_promo_codes_serialize(
      promo_code_query_params=promo_code_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def list_promo_codes_with_http_info(
    self,
    promo_code_query_params: PromoCodeQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[ListResponsePromotionCodeExternal]:
    """List Promo Codes


        :param promo_code_query_params: (required)
        :type promo_code_query_params: PromoCodeQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_promo_codes_serialize(
      promo_code_query_params=promo_code_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def list_promo_codes_without_preload_content(
    self,
    promo_code_query_params: PromoCodeQueryParams,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """List Promo Codes


        :param promo_code_query_params: (required)
        :type promo_code_query_params: PromoCodeQueryParams
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._list_promo_codes_serialize(
      promo_code_query_params=promo_code_query_params,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'ListResponsePromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _list_promo_codes_serialize(
    self,
    promo_code_query_params,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> RequestSerialized:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if promo_code_query_params is not None:
      _body_params = promo_code_query_params

    # set the HTTP header `Accept`
    if 'Accept' not in _header_params:
      _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='POST',
      resource_path='/promotion-codes/list',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )

  @validate_call
  def update_promo_code(
    self,
    promo_code_id: Annotated[StrictStr,
                             Field(description='Unique identifier of the PromotionCode.')],
    update_promo_code_request: UpdatePromoCodeRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> PromotionCodeExternal:
    """Update Promo Code


        :param promo_code_id: Unique identifier of the PromotionCode. (required)
        :type promo_code_id: str
        :param update_promo_code_request: (required)
        :type update_promo_code_request: UpdatePromoCodeRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_promo_code_serialize(
      promo_code_id=promo_code_id,
      update_promo_code_request=update_promo_code_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    ).data

  @validate_call
  def update_promo_code_with_http_info(
    self,
    promo_code_id: Annotated[StrictStr,
                             Field(description='Unique identifier of the PromotionCode.')],
    update_promo_code_request: UpdatePromoCodeRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> ApiResponse[PromotionCodeExternal]:
    """Update Promo Code


        :param promo_code_id: Unique identifier of the PromotionCode. (required)
        :type promo_code_id: str
        :param update_promo_code_request: (required)
        :type update_promo_code_request: UpdatePromoCodeRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_promo_code_serialize(
      promo_code_id=promo_code_id,
      update_promo_code_request=update_promo_code_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    response_data.read()
    return self.api_client.response_deserialize(
      response_data=response_data,
      response_types_map=_response_types_map,
    )

  @validate_call
  def update_promo_code_without_preload_content(
    self,
    promo_code_id: Annotated[StrictStr,
                             Field(description='Unique identifier of the PromotionCode.')],
    update_promo_code_request: UpdatePromoCodeRequest,
    _request_timeout: Union[None, Annotated[StrictFloat, Field(gt=0)],
                            Tuple[Annotated[StrictFloat, Field(gt=0)],
                                  Annotated[StrictFloat, Field(gt=0)]]] = None,
    _request_auth: Optional[Dict[StrictStr, Any]] = None,
    _content_type: Optional[StrictStr] = None,
    _headers: Optional[Dict[StrictStr, Any]] = None,
    _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
  ) -> RESTResponseType:
    """Update Promo Code


        :param promo_code_id: Unique identifier of the PromotionCode. (required)
        :type promo_code_id: str
        :param update_promo_code_request: (required)
        :type update_promo_code_request: UpdatePromoCodeRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

    _param = self._update_promo_code_serialize(
      promo_code_id=promo_code_id,
      update_promo_code_request=update_promo_code_request,
      _request_auth=_request_auth,
      _content_type=_content_type,
      _headers=_headers,
      _host_index=_host_index
    )

    _response_types_map: Dict[str, Optional[str]] = {
      '200': 'PromotionCodeExternal',
      '422': 'HTTPValidationError',
    }
    response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
    return response_data.response

  def _update_promo_code_serialize(
    self,
    promo_code_id,
    update_promo_code_request,
    _request_auth,
    _content_type,
    _headers,
    _host_index,
  ) -> RequestSerialized:

    _host = None

    _collection_formats: Dict[str, str] = {}

    _path_params: Dict[str, str] = {}
    _query_params: List[Tuple[str, str]] = []
    _header_params: Dict[str, Optional[str]] = _headers or {}
    _form_params: List[Tuple[str, str]] = []
    _files: Dict[str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]] = {}
    _body_params: Optional[bytes] = None

    # process the path parameters
    if promo_code_id is not None:
      _path_params['promo_code_id'] = promo_code_id
    # process the query parameters
    # process the header parameters
    # process the form parameters
    # process the body parameter
    if update_promo_code_request is not None:
      _body_params = update_promo_code_request

    # set the HTTP header `Accept`
    if 'Accept' not in _header_params:
      _header_params['Accept'] = self.api_client.select_header_accept(['application/json'])

    # set the HTTP header `Content-Type`
    if _content_type:
      _header_params['Content-Type'] = _content_type
    else:
      _default_content_type = (self.api_client.select_header_content_type(['application/json']))
      if _default_content_type is not None:
        _header_params['Content-Type'] = _default_content_type

    # authentication setting
    _auth_settings: List[str] = ['HTTPBearer']

    return self.api_client.param_serialize(
      method='PUT',
      resource_path='/promotion-codes/{promo_code_id}',
      path_params=_path_params,
      query_params=_query_params,
      header_params=_header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      auth_settings=_auth_settings,
      collection_formats=_collection_formats,
      _host=_host,
      _request_auth=_request_auth
    )
