# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from getopenpay.models.currency_enum import CurrencyEnum
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing_extensions import Self


class AuthorizePaymentMethodRequest(BaseModel):
  """
    AuthorizePaymentMethodRequest
    """

  # noqa: E501
  authorize_amount_atom: Optional[StrictInt] = Field(
    default=2000, description='Amount to authorize in atoms (smallest currency unit).'
  )
  currency: Optional[CurrencyEnum] = Field(
    default=None, description='Currency for the authorization amount.'
  )
  payment_method_id: StrictStr = Field(description='Unique identifier of the payment method.')
  __properties: ClassVar[List[str]] = ['authorize_amount_atom', 'currency', 'payment_method_id']

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of AuthorizePaymentMethodRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of AuthorizePaymentMethodRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'authorize_amount_atom':
          obj.get('authorize_amount_atom')
          if obj.get('authorize_amount_atom') is not None else 2000,
        'currency': obj.get('currency'),
        'payment_method_id': obj.get('payment_method_id')
      }
    )
    return _obj
