# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from getopenpay.models.billing_meter_adjustment_type import BillingMeterAdjustmentType
from getopenpay.models.billing_meter_event_adjustment_status import (
  BillingMeterEventAdjustmentStatus
)
from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing_extensions import Self


class BillingMeterEventAdjustmentExternal(BaseModel):
  """
    BillingMeterEventAdjustmentExternal
    """

  # noqa: E501
  account_id: StrictStr = Field(description='Unique identifier for the account.')
  cancel_identifier: StrictStr = Field(description='Unique identifier for the event.')
  created_at: datetime = Field(
    description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  event_name: StrictStr = Field(
    description='The name of the meter event. Corresponds with the event_name field on a meter.'
  )
  id: StrictStr = Field(description='Unique identifier of meter event.')
  is_deleted: Optional[StrictBool] = Field(
    default=False, description='If true, indicates that this object has been deleted'
  )
  object: Optional[ObjectName] = None
  status: BillingMeterEventAdjustmentStatus = Field(
    description='Status of the billing meter adjustment event.'
  )
  type: Optional[BillingMeterAdjustmentType] = Field(
    default=None, description='Specifies whether to cancel a single event.'
  )
  updated_at: datetime = Field(
    description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  __properties: ClassVar[List[str]] = [
    'account_id', 'cancel_identifier', 'created_at', 'event_name', 'id', 'is_deleted', 'object',
    'status', 'type', 'updated_at'
  ]

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of BillingMeterEventAdjustmentExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of BillingMeterEventAdjustmentExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'account_id': obj.get('account_id'),
        'cancel_identifier': obj.get('cancel_identifier'),
        'created_at': obj.get('created_at'),
        'event_name': obj.get('event_name'),
        'id': obj.get('id'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'object': obj.get('object'),
        'status': obj.get('status'),
        'type': obj.get('type'),
        'updated_at': obj.get('updated_at')
      }
    )
    return _obj
