# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from getopenpay.models.billing_meter_adjustment_type import BillingMeterAdjustmentType
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing_extensions import Self


class CreateBillingMeterEventAdjustmentRequest(BaseModel):
  """
    CreateBillingMeterEventAdjustmentRequest
    """

  # noqa: E501
  cancel_identifier: StrictStr = Field(description='Unique identifier for the event.')
  event_name: StrictStr = Field(
    description='The name of the meter event. Corresponds with the event_name field on a meter.'
  )
  type: Optional[BillingMeterAdjustmentType] = Field(
    default=None, description='Specifies whether to cancel a single event.'
  )
  __properties: ClassVar[List[str]] = ['cancel_identifier', 'event_name', 'type']

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of CreateBillingMeterEventAdjustmentRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of CreateBillingMeterEventAdjustmentRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'cancel_identifier': obj.get('cancel_identifier'),
        'event_name': obj.get('event_name'),
        'type': obj.get('type')
      }
    )
    return _obj
