# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set, Union

from getopenpay.models.calendar_interval_enum import CalendarIntervalEnum
from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.price_tier_params import PriceTierParams
from getopenpay.models.price_type_enum import PriceTypeEnum
from getopenpay.models.pricing_model import PricingModel
from getopenpay.models.usage_agg_method_enum import UsageAggMethodEnum
from getopenpay.models.usage_type_enum import UsageTypeEnum
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing_extensions import Self


class CreatePriceRequest(BaseModel):
  """
    CreatePriceRequest
    """

  # noqa: E501
  aggregate_usage: Optional[UsageAggMethodEnum] = Field(
    default=None,
    description="Specifies a usage aggregation strategy for prices of usage_type 'metered'."
  )
  billing_interval: Optional[CalendarIntervalEnum] = None
  billing_interval_count: Optional[StrictInt] = None
  can_only_be_purchased_with: Optional[List[StrictStr]] = Field(
    default=None,
    description=
    'This price can only be purchased in a subscription if subscriptioncontains at least one of these prices.'
  )
  contract_auto_renew: Optional[StrictBool] = None
  contract_term_multiple: Optional[StrictInt] = None
  currency: Optional[CurrencyEnum] = Field(
    default=None, description='Three-letter ISO currency code, in lowercase.'
  )
  default_net_d: Optional[StrictInt] = None
  internal_description: Optional[StrictStr] = None
  is_active: StrictBool = Field(description='Whether the price can be used for new purchases.')
  is_default: Optional[StrictBool] = None
  is_exclusive: Optional[StrictBool] = None
  listed_exclusively_for_customers: Optional[List[StrictStr]] = Field(
    default=None,
    description=
    'When listed_exclusively_for_customers is passed only customers under listed_exclusively_for_customers can list the given price. Anyone who has a payment_link containing the price can view and subscribe the prices regardless of it.Please do not pass a value if a price is not exclusive.'
  )
  meta: Optional[Dict[str, Any]] = None
  meter_id: Optional[StrictStr] = None
  name: Optional[StrictStr] = None
  price_tiers: Optional[List[PriceTierParams]] = Field(
    default=None, description='List of price_tiers.'
  )
  price_type: PriceTypeEnum = Field(
    description=
    'One of one_time or recurring depending on whether the price is for a one-time purchase or a recurring (subscription) purchase.'
  )
  pricing_model: PricingModel = Field(
    description='Indicates which pricing model to be used for product.'
  )
  product_id: StrictStr = Field(description='Unique identifier of the product.')
  transform_quantity_divide_by: Optional[Union[StrictFloat, StrictInt]] = Field(
    default=1.0,
    description=
    'This transformation will be applied on quantity before multiplying by unit_amount_atom.'
  )
  trial_period_days: Optional[StrictInt] = Field(
    default=0, description='Number of trail days for this Price.'
  )
  unit_amount_atom: Optional[StrictInt] = None
  usage_type: Optional[UsageTypeEnum] = Field(
    default=None,
    description=
    "Configures how the quantity per period should be determined. Can be either 'metered' or 'licensed'. 'licensed' automatically bills the quantity set when adding it to a subscription. 'metered' aggregates the total usage based on usage records. Defaults to 'licensed'."
  )
  __properties: ClassVar[List[str]] = [
    'aggregate_usage', 'billing_interval', 'billing_interval_count', 'can_only_be_purchased_with',
    'contract_auto_renew', 'contract_term_multiple', 'currency', 'default_net_d',
    'internal_description', 'is_active', 'is_default', 'is_exclusive',
    'listed_exclusively_for_customers', 'meta', 'meter_id', 'name', 'price_tiers', 'price_type',
    'pricing_model', 'product_id', 'transform_quantity_divide_by', 'trial_period_days',
    'unit_amount_atom', 'usage_type'
  ]

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of CreatePriceRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    # override the default output from pydantic by calling `to_dict()` of each item in price_tiers (list)
    _items = []
    if self.price_tiers:
      for _item_price_tiers in self.price_tiers:
        if _item_price_tiers:
          _items.append(_item_price_tiers.to_dict())
      _dict['price_tiers'] = _items
    # set to None if billing_interval (nullable) is None
    # and model_fields_set contains the field
    if self.billing_interval is None and 'billing_interval' in self.model_fields_set:
      _dict['billing_interval'] = None

    # set to None if billing_interval_count (nullable) is None
    # and model_fields_set contains the field
    if self.billing_interval_count is None and 'billing_interval_count' in self.model_fields_set:
      _dict['billing_interval_count'] = None

    # set to None if contract_auto_renew (nullable) is None
    # and model_fields_set contains the field
    if self.contract_auto_renew is None and 'contract_auto_renew' in self.model_fields_set:
      _dict['contract_auto_renew'] = None

    # set to None if contract_term_multiple (nullable) is None
    # and model_fields_set contains the field
    if self.contract_term_multiple is None and 'contract_term_multiple' in self.model_fields_set:
      _dict['contract_term_multiple'] = None

    # set to None if default_net_d (nullable) is None
    # and model_fields_set contains the field
    if self.default_net_d is None and 'default_net_d' in self.model_fields_set:
      _dict['default_net_d'] = None

    # set to None if internal_description (nullable) is None
    # and model_fields_set contains the field
    if self.internal_description is None and 'internal_description' in self.model_fields_set:
      _dict['internal_description'] = None

    # set to None if is_default (nullable) is None
    # and model_fields_set contains the field
    if self.is_default is None and 'is_default' in self.model_fields_set:
      _dict['is_default'] = None

    # set to None if is_exclusive (nullable) is None
    # and model_fields_set contains the field
    if self.is_exclusive is None and 'is_exclusive' in self.model_fields_set:
      _dict['is_exclusive'] = None

    # set to None if meta (nullable) is None
    # and model_fields_set contains the field
    if self.meta is None and 'meta' in self.model_fields_set:
      _dict['meta'] = None

    # set to None if meter_id (nullable) is None
    # and model_fields_set contains the field
    if self.meter_id is None and 'meter_id' in self.model_fields_set:
      _dict['meter_id'] = None

    # set to None if name (nullable) is None
    # and model_fields_set contains the field
    if self.name is None and 'name' in self.model_fields_set:
      _dict['name'] = None

    # set to None if unit_amount_atom (nullable) is None
    # and model_fields_set contains the field
    if self.unit_amount_atom is None and 'unit_amount_atom' in self.model_fields_set:
      _dict['unit_amount_atom'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of CreatePriceRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'aggregate_usage': obj.get('aggregate_usage'),
        'billing_interval': obj.get('billing_interval'),
        'billing_interval_count': obj.get('billing_interval_count'),
        'can_only_be_purchased_with': obj.get('can_only_be_purchased_with'),
        'contract_auto_renew': obj.get('contract_auto_renew'),
        'contract_term_multiple': obj.get('contract_term_multiple'),
        'currency': obj.get('currency'),
        'default_net_d': obj.get('default_net_d'),
        'internal_description': obj.get('internal_description'),
        'is_active': obj.get('is_active'),
        'is_default': obj.get('is_default'),
        'is_exclusive': obj.get('is_exclusive'),
        'listed_exclusively_for_customers': obj.get('listed_exclusively_for_customers'),
        'meta': obj.get('meta'),
        'meter_id': obj.get('meter_id'),
        'name': obj.get('name'),
        'price_tiers':
          [PriceTierParams.from_dict(_item) for _item in obj['price_tiers']]
          if obj.get('price_tiers') is not None else None,
        'price_type': obj.get('price_type'),
        'pricing_model': obj.get('pricing_model'),
        'product_id': obj.get('product_id'),
        'transform_quantity_divide_by':
          obj.get('transform_quantity_divide_by')
          if obj.get('transform_quantity_divide_by') is not None else 1.0,
        'trial_period_days':
          obj.get('trial_period_days') if obj.get('trial_period_days') is not None else 0,
        'unit_amount_atom': obj.get('unit_amount_atom'),
        'usage_type': obj.get('usage_type')
      }
    )
    return _obj
