# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from getopenpay.models.proration_enum import ProrationEnum
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing_extensions import Self


class CreateSubscriptionItemRequest(BaseModel):
  """
    CreateSubscriptionItemRequest
    """

  # noqa: E501
  add_at_period_end: Optional[StrictBool] = Field(
    default=False,
    description=
    'If the flag is set to True, item will be added when renewing the subscription at next billing cycle.'
  )
  custom_fields: Optional[Dict[str, Any]] = None
  description: Optional[StrictStr] = None
  price_id: StrictStr = Field(description='The ID of the price.')
  proration_behavior: Optional[ProrationEnum] = Field(
    default=None,
    description=
    'Determines how to handle prorations when the billable items changes.In case of subscription is in trialing state, invoice items if any will be for amount_atom 0.'
  )
  quantity: Optional[StrictInt] = Field(
    default=1,
    description="The quantity you'd like to apply to the subscription item you're creating."
  )
  subscription_id: StrictStr = Field(description='The identifier of the subscription to modify')
  __properties: ClassVar[List[str]] = [
    'add_at_period_end', 'custom_fields', 'description', 'price_id', 'proration_behavior',
    'quantity', 'subscription_id'
  ]

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of CreateSubscriptionItemRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    # set to None if custom_fields (nullable) is None
    # and model_fields_set contains the field
    if self.custom_fields is None and 'custom_fields' in self.model_fields_set:
      _dict['custom_fields'] = None

    # set to None if description (nullable) is None
    # and model_fields_set contains the field
    if self.description is None and 'description' in self.model_fields_set:
      _dict['description'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of CreateSubscriptionItemRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'add_at_period_end':
          obj.get('add_at_period_end') if obj.get('add_at_period_end') is not None else False,
        'custom_fields': obj.get('custom_fields'),
        'description': obj.get('description'),
        'price_id': obj.get('price_id'),
        'proration_behavior': obj.get('proration_behavior'),
        'quantity': obj.get('quantity') if obj.get('quantity') is not None else 1,
        'subscription_id': obj.get('subscription_id')
      }
    )
    return _obj
