# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from getopenpay.models.tax_integration_api_name import TaxIntegrationApiName
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing_extensions import Self


class CreateTaxIntegrationRequest(BaseModel):
  """
    CreateTaxIntegrationRequest
    """

  # noqa: E501
  accounting_tz: StrictStr = Field(
    description=
    'The timezone name for the accounting timezone (see pytz.all_timezones for a full list)'
  )
  api_keys: Dict[str, StrictStr] = Field(
    description='These keys will allow to authenticate API requests to the tax processor.'
  )
  api_name: TaxIntegrationApiName = Field(
    description='The name of the API used for the tax integration.'
  )
  __properties: ClassVar[List[str]] = ['accounting_tz', 'api_keys', 'api_name']

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of CreateTaxIntegrationRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of CreateTaxIntegrationRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'accounting_tz': obj.get('accounting_tz'),
        'api_keys': obj.get('api_keys'),
        'api_name': obj.get('api_name')
      }
    )
    return _obj
