# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from getopenpay.models.credit_note_line_type import CreditNoteLineType
from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing_extensions import Self


class CreditNoteItemExternal(BaseModel):
  """
    CreditNoteItemExternal
    """

  # noqa: E501
  amount_atom: StrictInt = Field(
    description=
    'The integer amount representing the gross amount being credited for this credit_note_item. It is in atomic units (in USD this is cents).'
  )
  created_at: datetime = Field(
    description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  currency: CurrencyEnum = Field(description='Three-letter ISO currency code, in lowercase.')
  id: StrictStr = Field(description='Unique Identifier of the credit_note_item.')
  invoice_item_id: Optional[StrictStr] = None
  is_deleted: Optional[StrictBool] = Field(
    default=False, description='If true, indicates that this object has been deleted'
  )
  object: Optional[ObjectName] = None
  quantity: Optional[StrictInt] = Field(
    default=1, description='Quantity of the product being credited.'
  )
  type: CreditNoteLineType = Field(
    description=
    'The type of the credit note line item, one of invoice_line_item or custom_line_item. When the type is invoice_line_item there is an additional invoice_line_item property on the resource the value of which is the id of the credited line item on the invoice.'
  )
  unit_amount_atom: Optional[StrictInt] = None
  updated_at: datetime = Field(
    description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  __properties: ClassVar[List[str]] = [
    'amount_atom', 'created_at', 'currency', 'id', 'invoice_item_id', 'is_deleted', 'object',
    'quantity', 'type', 'unit_amount_atom', 'updated_at'
  ]

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of CreditNoteItemExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    # set to None if invoice_item_id (nullable) is None
    # and model_fields_set contains the field
    if self.invoice_item_id is None and 'invoice_item_id' in self.model_fields_set:
      _dict['invoice_item_id'] = None

    # set to None if unit_amount_atom (nullable) is None
    # and model_fields_set contains the field
    if self.unit_amount_atom is None and 'unit_amount_atom' in self.model_fields_set:
      _dict['unit_amount_atom'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of CreditNoteItemExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'amount_atom': obj.get('amount_atom'),
        'created_at': obj.get('created_at'),
        'currency': obj.get('currency'),
        'id': obj.get('id'),
        'invoice_item_id': obj.get('invoice_item_id'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'object': obj.get('object'),
        'quantity': obj.get('quantity') if obj.get('quantity') is not None else 1,
        'type': obj.get('type'),
        'unit_amount_atom': obj.get('unit_amount_atom'),
        'updated_at': obj.get('updated_at')
      }
    )
    return _obj
