# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from getopenpay.models.event_type import EventType
from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing_extensions import Self


class EventExternal(BaseModel):
  """
    EventExternal
    """

  # noqa: E501
  account_id: Optional[StrictStr]
  created_at: datetime = Field(
    description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  data: Dict[str, Any]
  data_previous: Optional[Dict[str, Any]]
  id: StrictStr
  is_deleted: Optional[StrictBool] = Field(
    default=False, description='If true, indicates that this object has been deleted'
  )
  object: Optional[ObjectName] = None
  pending_webhooks: StrictInt
  request_id: Optional[StrictStr]
  request_idempotency_key: Optional[StrictStr]
  type: EventType
  updated_at: datetime = Field(
    description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  user: Optional[StrictStr] = None
  __properties: ClassVar[List[str]] = [
    'account_id', 'created_at', 'data', 'data_previous', 'id', 'is_deleted', 'object',
    'pending_webhooks', 'request_id', 'request_idempotency_key', 'type', 'updated_at', 'user'
  ]

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of EventExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    # set to None if account_id (nullable) is None
    # and model_fields_set contains the field
    if self.account_id is None and 'account_id' in self.model_fields_set:
      _dict['account_id'] = None

    # set to None if data_previous (nullable) is None
    # and model_fields_set contains the field
    if self.data_previous is None and 'data_previous' in self.model_fields_set:
      _dict['data_previous'] = None

    # set to None if request_id (nullable) is None
    # and model_fields_set contains the field
    if self.request_id is None and 'request_id' in self.model_fields_set:
      _dict['request_id'] = None

    # set to None if request_idempotency_key (nullable) is None
    # and model_fields_set contains the field
    if self.request_idempotency_key is None and 'request_idempotency_key' in self.model_fields_set:
      _dict['request_idempotency_key'] = None

    # set to None if user (nullable) is None
    # and model_fields_set contains the field
    if self.user is None and 'user' in self.model_fields_set:
      _dict['user'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of EventExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'account_id': obj.get('account_id'),
        'created_at': obj.get('created_at'),
        'data': obj.get('data'),
        'data_previous': obj.get('data_previous'),
        'id': obj.get('id'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'object': obj.get('object'),
        'pending_webhooks': obj.get('pending_webhooks'),
        'request_id': obj.get('request_id'),
        'request_idempotency_key': obj.get('request_idempotency_key'),
        'type': obj.get('type'),
        'updated_at': obj.get('updated_at'),
        'user': obj.get('user')
      }
    )
    return _obj
