# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set

from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing_extensions import Self


class ProductFamilyExternal(BaseModel):
  """
    ProductFamilyExternal
    """

  # noqa: E501
  created_at: datetime = Field(
    description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  description: Optional[StrictStr]
  hierarchy: Optional[StrictStr] = Field(
    default='{}', description='A JSON object representing the hierarchy within the family.'
  )
  id: StrictStr = Field(description='Unique identifier of the product family.')
  is_deleted: Optional[StrictBool] = Field(
    default=False, description='If true, indicates that this object has been deleted'
  )
  name: StrictStr = Field(description='Name of the product family.')
  object: Optional[ObjectName] = None
  products: List[StrictStr] = Field(description='List of products in the family')
  updated_at: datetime = Field(
    description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  __properties: ClassVar[List[str]] = [
    'created_at', 'description', 'hierarchy', 'id', 'is_deleted', 'name', 'object', 'products',
    'updated_at'
  ]

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of ProductFamilyExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    # set to None if description (nullable) is None
    # and model_fields_set contains the field
    if self.description is None and 'description' in self.model_fields_set:
      _dict['description'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of ProductFamilyExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'created_at': obj.get('created_at'),
        'description': obj.get('description'),
        'hierarchy': obj.get('hierarchy') if obj.get('hierarchy') is not None else '{}',
        'id': obj.get('id'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'name': obj.get('name'),
        'object': obj.get('object'),
        'products': obj.get('products'),
        'updated_at': obj.get('updated_at')
      }
    )
    return _obj
