# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from getopenpay.models.invoice_external import InvoiceExternal
from getopenpay.models.subscription_external import SubscriptionExternal
from pydantic import BaseModel, ConfigDict, Field
from typing_extensions import Self


class ResumeSubscriptionResponse(BaseModel):
  """
    ResumeSubscriptionResponse
    """

  # noqa: E501
  invoice: Optional[InvoiceExternal] = None
  subscription: SubscriptionExternal = Field(description='The subscription being resumed.')
  __properties: ClassVar[List[str]] = ['invoice', 'subscription']

  model_config = ConfigDict(
    populate_by_name=True,
    validate_assignment=True,
    protected_namespaces=(),
  )

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Optional[Self]:
    """Create an instance of ResumeSubscriptionResponse from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    excluded_fields: Set[str] = set([])

    _dict = self.model_dump(
      by_alias=True,
      exclude=excluded_fields,
      exclude_none=True,
    )
    # override the default output from pydantic by calling `to_dict()` of invoice
    if self.invoice:
      _dict['invoice'] = self.invoice.to_dict()
    # override the default output from pydantic by calling `to_dict()` of subscription
    if self.subscription:
      _dict['subscription'] = self.subscription.to_dict()
    # set to None if invoice (nullable) is None
    # and model_fields_set contains the field
    if self.invoice is None and 'invoice' in self.model_fields_set:
      _dict['invoice'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
    """Create an instance of ResumeSubscriptionResponse from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'invoice':
          InvoiceExternal.from_dict(obj['invoice']) if obj.get('invoice') is not None else None,
        'subscription':
          SubscriptionExternal.from_dict(obj['subscription'])
          if obj.get('subscription') is not None else None
      }
    )
    return _obj
